package com.ibm.rational.report.oda.reqpro.ui.impl;

import java.io.IOException;
import java.util.Properties;

import org.eclipse.datatools.connectivity.oda.OdaException;
import org.eclipse.datatools.connectivity.oda.design.ui.pages.impl.DefaultDataSourceWizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
/**
 * @author Suryakant Choudhary
 * @since 1.0
 */
public class ReqProDataSelectionWizardPage extends DefaultDataSourceWizardPage {
	
	private ReqProGuiHelper reqproGuiHelper = null;
    private Properties m_ReqproDataSourceProps = null;
	
	
	public ReqProDataSelectionWizardPage(String pageName) {
		super(pageName);
		setMessage(ReqProDriverResourceBundle.getString("GENERATEURLMSG"));
	}
	
	//@override
	public void createPageCustomControl( Composite parent )
	    {
	        if ( reqproGuiHelper == null )
	        	reqproGuiHelper = new ReqProGuiHelper(this);  
	        
	        try
	        {
	        	// Create the GUI 
	        	reqproGuiHelper.createCustomControl( parent );
	        }
	        catch( OdaException e )
	        {
	            e.printStackTrace();
	        }
	        
	        reqproGuiHelper.initCustomControl( m_ReqproDataSourceProps );   // in case init was called before create 
	    }
	
	public void setInitialProperties( Properties dataSourceProps )
	{
		m_ReqproDataSourceProps = dataSourceProps;
		if ( reqproGuiHelper == null )
			return; // ignore, wait till createPageCustomControl to initialize
		reqproGuiHelper.initCustomControl( m_ReqproDataSourceProps );
	}

	public Properties collectCustomProperties( )
	{
		if ( reqproGuiHelper != null )
			return reqproGuiHelper.collectCustomProperties( m_ReqproDataSourceProps );

		return ( m_ReqproDataSourceProps != null ) ? m_ReqproDataSourceProps
				: new Properties( );
	}
	
   
    public void refresh()
    {
        super.refresh();
        RESTDataSource.disableConrols();
    	 
    }
    
    public void performHelp()
    {
    	// Call the help Function 
    	RESTDataSource.performHelp();
    }
    
//    public boolean performFinish()
//    {
//    
//		return false;
//    	
//    }

}
