package com.ibm.rational.report.oda.reqpro.ui.impl;

import java.util.Properties;

import org.eclipse.datatools.enablement.oda.xml.ui.wizards.Constants;
import org.eclipse.datatools.enablement.oda.xml.ui.wizards.XMLInformationHolder;
import org.eclipse.datatools.enablement.oda.xml.ui.wizards.XPathChoosePage;
import org.eclipse.swt.widgets.Composite;

import com.ibm.rational.report.oda.reqpro.runtime.ReqProODARuntimePlugin;
import com.ibm.rational.report.oda.reqpro.runtime.impl.ReqProUserPromt;

import com.ibm.rational.report.oda.reqpro.ui.ReqProUIActivator;
/**
 * @author Suryakant Choudhary
 * @since 1.0
 */
public class ReqProTableMapping extends XPathChoosePage {
	
	public ReqProTableMapping( )
	{
		super();
	}

	/**
	 * @param pageName
	 */
	public ReqProTableMapping( String pageName )
	{
		super( pageName );
		
		
		
	}
	
	public void createPageCustomControl( Composite parent )
	{	
		
		
		if( XMLInformationHolder.hasDestroyed() )
			XMLInformationHolder.start( this.getInitializationDesign( ) );
		
//		 Use the Authorization information from the Cache if available 
//		 else ask the user to enter the information
		 String sXmlFileName = XMLInformationHolder.getPropertyValue( Constants.CONST_PROP_FILELIST );
			
		 int iFlag = -1;
		 
		 String url = "";
		//Check whether User Information is available in the URL
			if(sXmlFileName.indexOf("user") !=-1 && sXmlFileName.indexOf("password")!=-1)
			{
				// User Information already available
				iFlag = 1;
			}
			
			
			// Get the Project Name

			if (iFlag == -1) {
				
				// Whether REST Service or VegaDataServices
				int index  = sXmlFileName.indexOf("VegaDataServices");
				
				// Use the cached use info if available else ask for it
				String sUserName = "", sPassword = "" , sProjectName = "";
				
				// Get the project Name
				String temp = null;
				if(index != -1)
				{
					temp = sXmlFileName.substring(sXmlFileName
				       			.indexOf("requisitepro/")
						+ "requisitepro/".length());
					sProjectName = temp.substring(0, temp.indexOf("/"));
				}				
				else
				{
					temp = sXmlFileName.substring(sXmlFileName
							.indexOf("/Servlet/project/")
							+ "/Servlet/project/".length());
					
					// Check whether the information asked is about project structure or security or project details
					if(temp.indexOf("projectstructure") != -1
							||temp.indexOf("projectsecurity") != -1 
							||temp.indexOf("fulldetails")!= -1)
					{
						// Extract the project name
						sProjectName = temp.substring(0, temp.indexOf("?"));
						
					}
					else
					{					
						sProjectName = temp.substring(0, temp.indexOf("/"));
					}
					
				}
				// Check if the project information is available in cache
				temp = (String) ReqProUIActivator.mUserInfo.get(sProjectName);
				
				if(temp != null)
				{	// Information present in the cache
					sUserName = temp.substring(0,temp.indexOf(":$urya:"));	
					sPassword = temp.substring(temp.indexOf(":$urya:")+ ":$urya:".length());									
					
				}
				else
				{
					//Prompt the authentication Dialogue
			
					System.out.println("Project Name :" + sProjectName);
					// update the url with user information
					new ReqProUserPromt().createSShell(sProjectName);
					sUserName = ReqProUserPromt.getUserName();
					sPassword = ReqProUserPromt.getPassWord();
					
					// Cache this information
					ReqProODARuntimePlugin.mUserInfo.put(sProjectName,
							sUserName+":$urya:"+sPassword);
					
					// Caching the user info for Data Access
					ReqProUIActivator.mUserInfo.put(sProjectName, sUserName+":$urya:"+sPassword);
				}
			
				// Update the URL with the user information
				
				//Default is RDS
				
				if(index != -1)
				{
					url = composeRDSUrl(sXmlFileName, sUserName,  sPassword);
				}
				else // REST Services
				{
					url = composeRESTUrl(sXmlFileName, sUserName,  sPassword);
				}
				
				
				
			XMLInformationHolder.setPropertyValue(Constants.CONST_PROP_FILELIST, url);
			
			}
			else
			{
				XMLInformationHolder.setPropertyValue(Constants.CONST_PROP_FILELIST, sXmlFileName);
			}
		
		// Set the encoding property value
			XMLInformationHolder.setPropertyValue(Constants.CONST_PROP_ENCODINGLIST, "");
			
			System.out.println("The Final URL sent to Birt : "
				+ XMLInformationHolder.getPropertyValue( Constants.CONST_PROP_FILELIST ));
			
			System.out.println("The encoding : "
					+ XMLInformationHolder.getPropertyValue( Constants.CONST_PROP_ENCODINGLIST ));
		
		super.createPageCustomControl(parent);
		
	}
	
	private  String composeRDSUrl(String sXmlFileName, String userName, String password){
		String url = sXmlFileName;
		// Append the user credentials
		
		int index = url.lastIndexOf('?');
		if(index == -1) url += '?';
		else {
			url = sXmlFileName.substring(0,index);
			url += '?';
		}
		url += "username=" + userName + "&password=" + password;
		// append the filter information
		url += '&' + sXmlFileName.substring(sXmlFileName.lastIndexOf("?")+1);
		
		
		System.out.println(" URL after adding user info : "+ url);
		url = url.replaceAll(" ", "%20");
		return url;
	}

	private  String composeRESTUrl(String sXmlFileName, String userName, String password){
		String url = sXmlFileName;
		// Append the user credentials
		
		url += "&user=" + userName + "&password=" + password ;
		// append the filter information
		//url += '&' + sXmlFileName.substring(sXmlFileName.lastIndexOf("?")+1);
		
		
		System.out.println(" URL after adding user info : "+ url);
		url = url.replaceAll(" ", "%20");
		return url;
	}

}
